Public Class frmStart

    Private Sub btnSQLConnectionIntegrated_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSQLConnectionIntegrated.Click
        'Declare necessary variables
        Dim conn As SqlClient.SqlConnection
        Dim strConn As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDBFilename=" & _
            "'C:\Program Files\Microsoft SQL Server\MSSQL.1\" & _
            "MSSQL\Data\AdventureWorks_Data.mdf';" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Instantiate the SqlConnection object, passing it the 
        'connection string
        conn = New SqlClient.SqlConnection(strConn)

        'Open the connection
        conn.Open()

        'Display the connection string
        txtOutput.Text = conn.ConnectionString & " - " & "State = " & conn.State

        'Close the connection
        conn.Close()

    End Sub


    Private Sub btnSQLConnectionPassword_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSQLConnectionPassword.Click
        'Declare necessary variables
        Dim conn As SqlClient.SqlConnection
        Dim strConn As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename='C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';;" & _
            "Integrated Security=False;user id=sa;password=;Connect Timeout=30;User Instance=True"

        'Instantiate the SqlConnection object, passing it the 
        'connection string
        conn = New SqlClient.SqlConnection(strConn)

        'Open the connection
        conn.Open()

        'Display the connection string
        txtOutput.Text = conn.ConnectionString & " - " & "State = " & conn.State

        'Close the connection
        conn.Close()


    End Sub

    Private Sub btnSQLConnectionAlt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSQLConnectionAlt.Click
        'Declare necessary variables
        Dim conn As SqlClient.SqlConnection
        Dim strConn As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename='C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';;" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Instantiate the SqlConnection object, passing it the 
        'connection string
        conn = New SqlClient.SqlConnection()

        'Set ConnectionString property
        conn.ConnectionString = strConn

        'Open the connection
        conn.Open()

        'Display the connection string
        txtOutput.Text = conn.ConnectionString & " - " & "State = " & conn.State

        'Close the connection
        conn.Close()


    End Sub

    Private Sub btnSQLCommandSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSQLCommandSelect.Click
        'Declare necessary variables
        Dim cmd As SqlClient.SqlCommand
        Dim dr As SqlClient.SqlDataReader
        Dim conn As SqlClient.SqlConnection
        Dim strConn As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
            "'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Instantiate the SQLConnection object, passing it the 
        'connection string
        conn = New SqlClient.SqlConnection(strConn)

        'Open the connection
        conn.Open()

        'Instantiate the SqlCommand object
        cmd = New SqlClient.SqlCommand()

        'Set the CommandText property
        cmd.CommandText = "SELECT  SalesOrderID, OrderDate, DueDate, " & _
            "ShipDate, CustomerID, SubTotal, TaxAmt, Freight, TotalDue " & _
            "FROM Sales.SalesOrderHeader " & _
            "ORDER BY OrderDate"

        'Designate the CommandType
        cmd.CommandType = Data.CommandType.Text

        'Set the Connection property of the SqlCommand
        cmd.Connection = conn

        'Place results in a DataReader object
        dr = cmd.ExecuteReader

        'Output contents of DataReader to a grid
        Dim source As New BindingSource
        source.DataSource = source
        grdOutput.DataSource = source

        'Close the connection
        conn.Close()

    End Sub

    Private Sub btnCommandSelectSingle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCommandSelectSingle.Click
        'Declare necessary variables
        Dim cmd As SqlClient.SqlCommand
        Dim conn As SqlClient.SqlConnection
        Dim strConn As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
            "'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';;" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Instantiate the SQLConnection object, passing it the 
        'connection string
        conn = New SqlClient.SqlConnection(strConn)

        'Open the connection
        conn.Open()

        'Instantiate the SqlCommand object
        cmd = New SqlClient.SqlCommand()

        'Set the CommandText property
        cmd.CommandText = "SELECT COUNT(SalesOrderID) AS NumHighFreight " & _
            "FROM Sales.SalesOrderHeader " & _
            "WHERE Freight > 500"

        'Designate the CommandType
        cmd.CommandType = Data.CommandType.Text

        'Set the Connection property of the SqlCommand
        cmd.Connection = conn

        'Populate the Label with the output
        txtOutput.Text = CStr(cmd.ExecuteScalar)

        'Close the connection
        conn.Close()

    End Sub

    Private Sub btnCommandUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCommandUpdate.Click
        'Declare necessary variables
        Dim cmd As SqlClient.SqlCommand
        Dim conn As SqlClient.SqlConnection
        Dim strConn As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
            "'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';;" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Instantiate the SQLConnection object, passing it the 
        'connection string
        conn = New SqlClient.SqlConnection(strConn)

        'Open the connection
        conn.Open()

        'Instantiate the SqlCommand object
        cmd = New SqlClient.SqlCommand()

        'Set the CommandText property
        cmd.CommandText = "UPDATE Sales.SalesOrderHeader " & _
            "SET Freight = Freight + 1 " & _
            "WHERE SalesOrderID = 43659"

        'Designate the CommandType
        cmd.CommandType = Data.CommandType.Text

        'Set the Connection property of the SqlCommand
        cmd.Connection = conn

        'Populate the Label with the output
        txtOutput.Text = cmd.ExecuteNonQuery.ToString

        'Close the connection
        conn.Close()

    End Sub

    Private Sub btnDataReader_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDataReader.Click
        Dim conn As SqlClient.SqlConnection
        Dim dr As SqlClient.SqlDataReader
        Dim cmd As SqlClient.SqlCommand
        Dim strConn As String
        Dim strSQL As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
            "'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';;" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Build the SELECT statement
        strSQL = "SELECT ContactID, LastName " & _
                "FROM Person.Contact " & _
                "ORDER BY LastName"

        'Instantiate and open the connection
        conn = New SqlClient.SqlConnection(strConn)
        conn.Open()

        'Instantiate the SqlCommand object
        cmd = New SqlClient.SqlCommand(strSQL, conn)

        'Use the ExecuteReader method of the SqlCommand object
        'to execute the SQL statement and return the results
        'into the DataReader object
        dr = cmd.ExecuteReader

        'Display results in a DropDownList
        If Not dr Is Nothing Then
            While (dr.Read())
                ddlContacts.Items.Add(dr("LastName"))
            End While
        End If

        dr.Close()
        conn.Close()

    End Sub

    Private Sub btnDataReaderLoop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDataReaderLoop.Click
        Dim conn As SqlClient.SqlConnection
        Dim dr As SqlClient.SqlDataReader
        Dim cmd As SqlClient.SqlCommand
        Dim strConn As String
        Dim strSQL As String
        Dim strOutput As New System.Text.StringBuilder()

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
            "'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';;" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Build the SELECT statement
        strSQL = "SELECT DepartmentID, Name " & _
                "FROM HumanResources.Department " & _
                "ORDER BY Name"

        'Instantiate and open the connection
        conn = New SqlClient.SqlConnection(strConn)
        conn.Open()

        'Instantiate the SqlCommand object
        cmd = New SqlClient.SqlCommand(strSQL, conn)

        'Use the ExecuteReader method of the SqlCommand object
        'to execute the SQL statement and return the results
        'into the DataReader object
        dr = cmd.ExecuteReader

        'Loop through the DataReader appending to the DataReader object
        While dr.Read
            strOutput.Append(dr.GetString(1) & ", ")
        End While

        'Display the contents of the StringBuilder object in a textbox
        txtOutput.Text = strOutput.ToString

        dr.Close()
        conn.Close()

    End Sub

    Private Sub btnDataAdapter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDataAdapter.Click
        Dim da As SqlClient.SqlDataAdapter
        Dim ds As New DataSet()
        Dim strConn As String
        Dim strSQL As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
            "'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Build the SELECT statement
        strSQL = "SELECT  SalesOrderID, OrderDate, DueDate, " & _
            "ShipDate, CustomerID, SubTotal, TaxAmt, Freight, TotalDue " & _
            "FROM Sales.SalesOrderHeader " & _
            "ORDER BY OrderDate"

        'Instantiate the SqlDataAdapter
        da = New SqlClient.SqlDataAdapter(strSQL, strConn)

        'Use the Fill method of the DataAdapter to
        'fill a DataSet with data
        da.Fill(ds, "SalesOrderHeader")

        'Display the contents of the stringbuilder object in a textbox
        grdOutput.DataSource = ds.Tables("SalesOrderHeader")

        ds.Dispose()
        da.Dispose()


    End Sub

    Private Sub btnDataSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDataSet.Click
        Dim da As SqlClient.SqlDataAdapter
        Dim ds As New DataSet()
        Dim strConn As String
        Dim strSQL As String
        Dim strOutput As New System.Text.StringBuilder()

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
            "'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';;" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Build the SELECT statement
        strSQL = "SELECT  SalesOrderID, OrderDate, DueDate, " & _
            "ShipDate, CustomerID, SubTotal, TaxAmt, Freight, TotalDue " & _
            "FROM Sales.SalesOrderHeader " & _
            "ORDER BY OrderDate"

        'Instantiate the SqlDataAdapter
        da = New SqlClient.SqlDataAdapter(strSQL, strConn)

        'Use the Fill method of the DataAdapter to
        'fill a DataSet with data
        da.Fill(ds, "SalesOrderHeader")

        'Populate a grid with data from the DataSet
        grdOutput.DataSource = ds.Tables("SalesOrderHeader")

        ds.Dispose()
        da.Dispose()

    End Sub

    Private Sub btnMultipleTables_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMultipleTables.Click

        Dim daOrders As SqlClient.SqlDataAdapter
        Dim daOrderDetails As SqlClient.SqlDataAdapter
        Dim rel As DataRelation
        Dim ds As New DataSet()
        Dim strConn As String
        Dim strSQL1 As String
        Dim strSQL2 As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
            "'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';;" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Build the SELECT statements
        strSQL1 = "SELECT SalesOrderID, OrderDate, DueDate, " & _
        "ShipDate, CustomerID, SubTotal, TaxAmt, Freight, TotalDue " & _
        "FROM Sales.SalesOrderHeader WHERE SalesOrderID >= 75061 " & _
        "ORDER BY OrderDate"

        strSQL2 = "SELECT SalesOrderDetailID, SalesOrderID, ProductID, OrderQty, UnitPrice " & _
            "FROM Sales.SalesOrderDetail WHERE SalesOrderID >= 75061"

        'Instantiate the SqlDataAdapters
        daOrders = New SqlClient.SqlDataAdapter(strSQL1, strConn)
        daOrderDetails = New SqlClient.SqlDataAdapter(strSQL2, strConn)

        'Use the Fill method of the DataAdapters to
        'fill a DataSet with data from both tables
        daOrders.Fill(ds, "SalesOrderHeader")
        daOrderDetails.Fill(ds, "SalesOrderDetail")

        'Create the DataRelation object and set its 
        'Nested property to True
        rel = New DataRelation("OrdersOrderDetail", _
            ds.Tables("SalesOrderHeader").Columns("SalesOrderID"), _
            ds.Tables("SalesOrderDetail").Columns("SalesOrderID"))
        rel.Nested = True

        'Add the DataRelation object 
        'to the Relations collection of the DataSet
        ds.Relations.Add(rel)

        'Display the XML stream in a textbox
        txtOutput.Text = ds.GetXml

        ds.Dispose()
        daOrders.Dispose()
        daOrderDetails.Dispose()


    End Sub

    Private Sub btnRelations_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRelations.Click
        Dim daSalesOrderHeader As SqlClient.SqlDataAdapter
        Dim daSalesOrderDetail As SqlClient.SqlDataAdapter
        Dim ds As New DataSet()
        Dim strConn As String
        Dim strSQL1 As String
        Dim strSQL2 As String
        Dim rel As DataRelation

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
            "'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';;" & _
            "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Build the SELECT statements
        strSQL1 = "SELECT SalesOrderID, OrderDate, DueDate, " & _
        "ShipDate, CustomerID, SubTotal, TaxAmt, Freight, TotalDue " & _
        "FROM Sales.SalesOrderHeader WHERE SalesOrderID >= 75061 " & _
        "ORDER BY OrderDate"
        strSQL2 = "SELECT SalesOrderDetailID, SalesOrderID, ProductID, OrderQty, UnitPrice " & _
            "FROM Sales.SalesOrderDetail WHER SalesOrderID >= 75061"

        'Instantiate the SqlDataAdapters
        daSalesOrderHeader = New SqlClient.SqlDataAdapter(strSQL1, strConn)
        daSalesOrderDetail = New SqlClient.SqlDataAdapter(strSQL2, strConn)

        'Use the Fill method of the DataAdapters to
        'fill a DataSet with data from both tables
        daSalesOrderHeader.Fill(ds, "SalesOrderHeader")
        daSalesOrderDetail.Fill(ds, "SalesOrderDetail")

        'Create the DataRelation object and set its 
        'Nested property to True
        rel = New DataRelation("HeaderDetail", _
            ds.Tables("SalesOrderHeader").Columns("SalesOrderID"), _
            ds.Tables("SalesOrderDetail").Columns("SalesOrderID"))
        rel.Nested = True

        'Add the DataRelation object 
        'to the Relations collection of the DataSet
        ds.Relations.Add(rel)

        'Display the XML stream in a label
        txtOutput.Text = ds.GetXml

        ds.Dispose()
        daSalesOrderHeader.Dispose()
        daSalesOrderDetail.Dispose()


    End Sub

    Private Sub btnInsert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInsert.Click
        'Declare necessary variables
        Dim cmd As New SqlClient.SqlCommand()
        Dim conn As SqlClient.SqlConnection
        Dim da As New SqlClient.SqlDataAdapter()
        Dim ds As New DataSet()
        Dim strConn As String
        Dim strSQL As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
           "'C:\Program Files\Microsoft SQL Server\" & _
           "MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';" & _
           "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Instantiate the SqlConnection object, passing it the 
        'connection string
        conn = New SqlClient.SqlConnection(strConn)

        'Open the connection
        conn.Open()

        'Instantiate the SqlCommand object
        cmd = New SqlClient.SqlCommand()

        'Set the CommandText property
        cmd.CommandText = "INSERT INTO HumanResources.Department " & _
            "(Name, GroupName) " & _
            "VALUES (@Name, @GroupName) "

        'Designate the CommandType
        cmd.CommandType = CommandType.Text

        'Set the Connection property of the SqlCommand
        cmd.Connection = conn

        'Add parameters and set their values
        'NOTE THAT THE ORDER DOESN'T MATTER!
        Dim nameParameter As New SqlClient.SqlParameter("@Name", SqlDbType.NVarChar)
        nameParameter.Value = txtName.Text
        cmd.Parameters.Add(nameParameter)

        Dim groupNameParameter As New SqlClient.SqlParameter("@GroupName", SqlDbType.NVarChar)
        groupNameParameter.Value = txtGroupName.Text
        cmd.Parameters.Add(groupNameParameter)

        'Execute the Insert statement
        cmd.ExecuteNonQuery()

        'Fill the DataSet with data from the inserted row
        strSQL = "SELECT DepartmentID, Name, GroupName " & _
            "FROM HumanResources.Department " & _
            "WHERE Name = '" & _
            txtName.Text & "' And " & _
            "GroupName = '" & txtGroupName.Text & "'"
        da = New SqlClient.SqlDataAdapter(strSQL, conn)
        da.Fill(ds, "DepartmentInfo")

        'Display the contents of the stringbuilder object in a textbox
        txtOutput.Text = ds.ToString

        'Close the connection
        conn.Close()



    End Sub

    Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
        'Declare necessary variables
        Dim cmd As New SqlClient.SqlCommand()
        Dim conn As SqlClient.SqlConnection
        Dim da As New SqlClient.SqlDataAdapter()
        Dim ds As New DataSet()
        Dim strConn As String
        Dim strSQL As String


        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
           "'C:\Program Files\Microsoft SQL Server\" & _
           "MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';" & _
           "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Instantiate the SqlConnection object, passing it the 
        'connection string
        conn = New SqlClient.SqlConnection(strConn)

        'Open the connection
        conn.Open()

        'Instantiate the SqlCommand object
        cmd = New SqlClient.SqlCommand()

        'Set the CommandText property
        cmd.CommandText = "UPDATE HumanResources.Department " & _
            "SET Name = @Name, " & _
            "GroupName = @GroupName " & _
            "WHERE DepartmentID = @DepartmentIDCriteria"

        'Designate the CommandType
        cmd.CommandType = CommandType.Text

        'Set the Connection property of the SqlCommand
        cmd.Connection = conn

        'Add parameters and set their values
        'NOTE THAT THE ORDER DOESN'T MATTER!
        cmd.Parameters.Add _
            (New SqlClient.SqlParameter("@DepartmentIDCriteria", _
            SqlDbType.SmallInt)).Value = Convert.ToInt32(txtDepartmentID.Text)
        cmd.Parameters.Add _
            (New SqlClient.SqlParameter("@Name", _
            SqlDbType.NVarChar)).Value = txtName.Text
        cmd.Parameters.Add _
            (New SqlClient.SqlParameter("@GroupName", _
            SqlDbType.NVarChar)).Value = txtGroupName.Text

        'Execute the Insert statement
        cmd.ExecuteNonQuery()

        'Fill the DataSet with data from the updated row
        strSQL = "SELECT DepartmentID, Name, GroupName " & _
            "FROM HumanResources.Department " & _
            "WHERE DepartmentID = '" & _
            txtDepartmentID.Text & "'"
        da = New SqlClient.SqlDataAdapter(strSQL, conn)
        da.Fill(ds, "DepartmentInformation")

        'Display the contents of the stringbuilder object in a textbox
        txtOutput.Text = ds.ToString

        'Close the connection
        conn.Close()

    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        'Declare necessary variables
        Dim cmd As New SqlClient.SqlCommand()
        Dim conn As SqlClient.SqlConnection
        Dim da As New SqlClient.SqlDataAdapter()
        Dim ds As New DataSet()
        Dim strConn As String
        Dim strSQL As String

        'Build a connection string
        strConn = "Data Source=.\SQLEXPRESS;AttachDbFilename=" & _
           "'C:\Program Files\Microsoft SQL Server\" & _
           "MSSQL.1\MSSQL\Data\AdventureWorks_Data.mdf';" & _
           "Integrated Security=True;Connect Timeout=30;User Instance=True"

        'Instantiate the SqlConnection object, passing it the 
        'connection string
        conn = New SqlClient.SqlConnection(strConn)

        'Open the connection
        conn.Open()

        'Instantiate the SqlCommand object
        cmd = New SqlClient.SqlCommand()

        'Set the CommandText property
        cmd.CommandText = "DELETE FROM HumanResources.Department " & _
            "WHERE DepartmentID = @DepartmentIDCriteria"

        'Designate the CommandType
        cmd.CommandType = CommandType.Text

        'Set the Connection property of the SqlCommand
        cmd.Connection = conn

        'Add parameters and set their values
        'NOTE THAT THE ORDER DOESN'T MATTER!
        cmd.Parameters.Add _
            (New SqlClient.SqlParameter("@DepartmentIDCriteria", _
            SqlDbType.NChar, 5)).Value = txtDepartmentID.Text

        'Execute the Delete statement
        cmd.ExecuteNonQuery()

        'Fill the DataSet with data from the deleted row
        strSQL = "SELECT DepartmentID, Name, GroupName " & _
            "FROM HumanResources.Department " & _
            "WHERE DepartmentID = '" & _
            txtDepartmentID.Text & "'"
        da = New SqlClient.SqlDataAdapter(strSQL, conn)
        da.Fill(ds, "Departments")

        'Display the contents of the stringbuilder object in a textbox
        txtOutput.Text = ds.ToString

        'Close the connection
        conn.Close()


    End Sub

End Class
